# Akida PCIe driver

## 1 - Driver retrieval
Unzip the release (1.0.1.zip file provided) and open a shell from the unzip destination folder.

## 2 - Building the driver
Prerequisite:
```
sudo apt install build-essential
```
Then run the following commands:
```
cd pedd
make
```
A `pedd-bc.ko` kernel module is created in the same folder.

## 3 - Installing the driver
### 3.1 - Manual installation
From the command line, run:
```
sudo insmod ./pedd-bc.ko
sudo cp ../scripts/99-akida-pcie.rules /etc/udev/rules.d
sudo udevadm trigger
```
_Note : to uninstall the driver, enter: `sudo rmmod pedd_bc`_

### 3.2 - Configuration to get the driver loaded on every boot
Follow manual installation steps, then run:
```
sudo cp ./pedd-bc.ko /lib/modules/$(uname -r)/kernel/drivers/
echo 'pedd_bc' | sudo tee -a /etc/modules
sudo depmod
```

### 3.3 - (Optional) Disabling Ubuntu kernel updates
Ubuntu automatic updates may break the kernel compatibility with the module.
To avoid that, you can mark the kernel to "hold", so it does not get upgraded:
```
sudo apt-mark hold `uname -r`
```
Then edit `/etc/apt/apt.conf.d/50unattended-upgrades` and uncomment the `"linux-";` line (or add it if missing):
```
// Python regular expressions, matching packages to exclude from upgrading
Unattended-Upgrade::Package-Blacklist {
    // The following matches all packages starting with linux-
    "linux-";
```
_Note : this means no security updates will be applied on this kernel._
