/* SPDX-License-Identifier: GPL-2.0 */
/*
 * Copyright (c) 2018 Synopsys, Inc. and/or its affiliates.
 * Synopsys DesignWare eDMA controller driver.
 */

#ifndef __PEDD_CMD_H__
#define __PEDD_CMD_H__

#include "pedd_types.h"

#define PEDD_CTL_CODE(c)

#define PEDD_IOCTL_APP_CMD      PEDD_CTL_CODE(2)

#define isdigit(c) ((c) >= '0' && (c) <= '9')
#define islower(c) ((c) >= 'a' && (c) <= 'z')
#define toupper(c) \
      ( ((c) >= 'a' && (c) <= 'z') ? ((char)('A'+((c)-'a'))) : (c) )
#define isxdigit(c) \
      (isdigit(c) || ((c) >= 'a' && (c) <= 'f') || ((c) >= 'A' && (c) <= 'F'))


typedef enum {
    PEDD_CB_VAL_IDX,
    PEDD_CB_REG_IDX,
    PEDD_CB_BAR_IDX,
    PEDD_CB_OFFSET_IDX,
    PEDD_CB_SIZE_IDX,
    PEDD_CB_CHAN_IDX,
    PEDD_CB_LEN_IDX,
    PEDD_CB_CHECK_IDX,
    PEDD_CB_LLE_IDX,
    PEDD_CB_DIRC_IDX,
    PEDD_CB_LB_IDX,
    PEDD_CB_RECYC_IDX,
    PEDD_CB_WM_IDX,
    PEDD_CB_QUEUE_IDX,
    PEDD_CB_DDR_IDX,
    PEDD_CB_END_IDX,
    PEDD_CB_WEI_IDX,
    PEDD_CB_UP_IDX,

    PEDD_CB_NUM_ARGS        // Total numbers
}PEDD_CB;

typedef struct __lux_parse_cmd_t
{
   char            *arg;          /* arg name */
   ULONG           default_val;   /* default val if arg not on commandline */
} lux_parse_cmd_t;

typedef struct __lux_parse_t
{
   ULONG            ncmds;    /* number of valid args */
   lux_parse_cmd_t  *args;    /* array of valid args */
} lux_parse_t;

int pedd_parse_cmd( char *cmdline, char *cmd, unsigned long *arg_vals);
int lux_parse_cmd_args( lux_parse_t *arg_set, char *cmdline, char *cmd, unsigned long *arg_vals);

#endif  //__PEDD_CMD_H__
